



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android学习——百度地图开发定位与显示Demo</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android学习——百度地图开发定位与显示Demo</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 00:07:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>百度地图给我们提供了很丰富的API供我们进行二次开发。百度地图的SDK与定位SDK在今年6月份进行了更新。</p>
<p>地图更新为3.0，定位更新为4.2。百度说：这次更新对接口有了较大部分的调整，与之前版本号不兼容。</p>
<p>本篇博文基于以上最新版本号的API提供一个小样例：获取自己当前的经纬度坐标，而且显示在地图上。这里仅仅给出核心代码。其它KEY的引入。地图控件的加入，权限的声明。定位服务的声明可在百度地图API官网（http://developer.baidu.com/map/sdkandev-download.htm）进行查看，稍候会附上完整样例的下载链接。</p>
<p>代码中的凝视已经比較具体了。这里就不做说明，參考官网非常easy理解。</p>
<pre class="prettyprint linenums">package org.zsl.android.map;

import android.app.Activity;<br />
import android.os.Bundle;<br />
import android.util.Log;

import com.baidu.location.BDLocation;<br />
import com.baidu.location.BDLocationListener;<br />
import com.baidu.location.LocationClient;<br />
import com.baidu.location.LocationClientOption;<br />
import com.baidu.mapapi.SDKInitializer;<br />
import com.baidu.mapapi.map.BaiduMap;<br />
import com.baidu.mapapi.map.BitmapDescriptor;<br />
import com.baidu.mapapi.map.MapStatusUpdate;<br />
import com.baidu.mapapi.map.MapStatusUpdateFactory;<br />
import com.baidu.mapapi.map.MapView;<br />
import com.baidu.mapapi.map.MyLocationData;<br />
import com.baidu.mapapi.model.LatLng;

public class MainActivity extends Activity {<br />
	public MapView mapView = null;<br />
	public BaiduMap baiduMap = null;

	// 定位相关声明<br />
	public LocationClient locationClient = null;<br />
	//自己定义图标<br />
	BitmapDescriptor mCurrentMarker = null;<br />
	boolean isFirstLoc = true;// 是否首次定位

	public BDLocationListener myListener = new BDLocationListener() {<br />
		@Override<br />
		public void onReceiveLocation(BDLocation location) {<br />
			// map view 销毁后不在处理新接收的位置<br />
			if (location == null || mapView == null)<br />
				return;

			MyLocationData locData = new MyLocationData.Builder()<br />
					.accuracy(location.getRadius())<br />
					// 此处设置开发人员获取到的方向信息。顺时针0-360<br />
					.direction(100).latitude(location.getLatitude())<br />
					.longitude(location.getLongitude()).build();<br />
			baiduMap.setMyLocationData(locData);	//设置定位数据

			if (isFirstLoc) {<br />
				isFirstLoc = false;

				LatLng ll = new LatLng(location.getLatitude(),<br />
						location.getLongitude());<br />
				MapStatusUpdate u = MapStatusUpdateFactory.newLatLngZoom(ll, 16);	//设置地图中心点以及缩放级别<br />
//				MapStatusUpdate u = MapStatusUpdateFactory.newLatLng(ll);<br />
				baiduMap.animateMapStatus(u);<br />
			}<br />
		}<br />
	};

	@Override<br />
	protected void onCreate(Bundle savedInstanceState) {<br />
		super.onCreate(savedInstanceState);<br />
		// 在使用SDK各组件之前初始化context信息。传入ApplicationContext<br />
		// 注意该方法要再setContentView方法之前实现<br />
		SDKInitializer.initialize(getApplicationContext());<br />
		setContentView(R.layout.main_activity);

		mapView = (MapView) this.findViewById(R.id.mapView); // 获取地图控件引用<br />
		baiduMap = mapView.getMap();<br />
		//开启定位图层<br />
		baiduMap.setMyLocationEnabled(true);

		locationClient = new LocationClient(getApplicationContext()); // 实例化LocationClient类<br />
		locationClient.registerLocationListener(myListener); // 注冊监听函数<br />
		this.setLocationOption();	//设置定位參数<br />
		locationClient.start(); // 開始定位<br />
		// baiduMap.setMapType(BaiduMap.MAP_TYPE_NORMAL); // 设置为一般地图

		// baiduMap.setMapType(BaiduMap.MAP_TYPE_SATELLITE); //设置为卫星地图<br />
		// baiduMap.setTrafficEnabled(true); //开启交通图

	}

	// 三个状态实现地图生命周期管理<br />
	@Override<br />
	protected void onDestroy() {<br />
		//退出时销毁定位<br />
		locationClient.stop();<br />
		baiduMap.setMyLocationEnabled(false);<br />
		// TODO Auto-generated method stub<br />
		super.onDestroy();<br />
		mapView.onDestroy();<br />
		mapView = null;<br />
	}

	@Override<br />
	protected void onResume() {<br />
		// TODO Auto-generated method stub<br />
		super.onResume();<br />
		mapView.onResume();<br />
	}

	@Override<br />
	protected void onPause() {<br />
		// TODO Auto-generated method stub<br />
		super.onPause();<br />
		mapView.onPause();<br />
	}

	/**<br />
	 * 设置定位參数<br />
	 */<br />
	private void setLocationOption() {<br />
		LocationClientOption option = new LocationClientOption();<br />
		option.setOpenGps(true); // 打开GPS<br />
		option.setLocationMode(LocationClientOption.LocationMode.Hight_Accuracy);// 设置定位模式<br />
		option.setCoorType(&quot;bd09ll&quot;); // 返回的定位结果是百度经纬度,默认值gcj02<br />
		option.setScanSpan(5000); // 设置发起定位请求的间隔时间为5000ms<br />
		option.setIsNeedAddress(true); // 返回的定位结果包括地址信息<br />
		option.setNeedDeviceDirect(true); // 返回的定位结果包括手机机头的方向

		locationClient.setLocOption(option);<br />
	}

}
</pre>

<p>完整源代码下载地址：<a href="http://download.csdn.net/detail/u012909091/7601647" rel="external nofollow noreferrer">http://download.csdn.net/detail/u012909091/7601647</a></p>
<p>（本文地址：http://blog.csdn.net/zhshulin/article/details/37495575）</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4kdx09.html">web安全之文件上传漏洞</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p213y8.html">&lbrack;IOS&rsqb;《A Swift Tour》翻译（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvm4njq.html">Android stuido viewpagerindicator的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2pz6v8.html">Linux Shell 02 流程控制语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1eny49.html">DB，Cache和Redis应用场景分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdegk6v9.html">HTML&plus;CSS学习笔记&lpar;1&rpar; - Html介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok3r0e9.html">Java语法糖</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvp4vxq.html">silverlight中DataGrid数据高亮显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ov5d49.html">数据库分库分表&lpar;sharding&rpar;系列&lpar;三&rpar; 关于使用框架还是自主开发以及sharding实现层面的考量</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kvzx49.html">&lbrack;ios&rsqb; NSURL</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk4p4j8.html">Android-AnsyncTask异步任务</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y1j4n8.html">OSX 鼠标和键盘事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9genpz48.html">CSS3常用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj76py8.html">软件测试实验二----selenium、katalon、junit</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rv4pj9.html">Django-api认证</a>
		</li>
						<li><a href="https://www.batexi.com/a/960owy39.html">Oracle 动态SQL 注意细节 ORA-00911&colon; 无效字符</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j104649.html">centos7 安装php gd库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwwlpz9.html">Xamarin&period;Android 隐藏软键盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvmv1r8.html">CentOS下Docker安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2yzgz9.html">leecode第十六题（最接近的三数之和）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8mno7moq.html">html文件引入其它html文件的几种方法：include方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmn7n49.html">C&plus;&plus; typedef</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde6np79.html">python自学笔记（八）python语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x0e209.html">Ubuntu在ARM上建立NFS服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okx7wx9.html">java处理图片时找到不sun&period;awt&period;X11GraphicsEnvironment问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1rryj8.html">systemd&period;service 中文手册</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w773xq.html">c&plus;&plus; bitset使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1ppke9.html">perl5 第一章 概述</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m7vk38.html">Oracle 经典SQL 专为笔试准备</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1w1wdq.html">道路软件质量：SourceMonitor</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
